program Font2Txt;

type
 TFont = array[1..12,0..2] of byte;
 TFnt = array[0..255] of TFont;
 TTxt = array[0..23] of string[13];

const
 Bits : array[0..23] of byte = (0,2,1,3, 4,6,8,10,12,14,16,18,
                                         5,7,9,11,13,15,17,19,
                                20,22,21,23);

var
 Ps, i : Integer;
 Ch : Byte;
 T : Text;
 F : File;
 S : String;
 Font : TFnt;
 Txt : TTxt;

Procedure Fnt2Txt(Const Font: TFnt; Ch : byte; Var Txt: TTxt);
var
 i, k: Integer;
 L: Longint;
begin
 L := 0;
 FillChar(Txt, SizeOf(Txt), 12);
 for k := 1 to 12 do
  begin
   move(Font[Ch,k,0], L, 3);
    for i := 0 to 23 do
     if (L and (Longint(1) shl i)) <> 0 then Txt[Bits[i]][k] := '*'
     else Txt[Bits[i]][k] := ' '
  end;
end;

begin
 WriteLn('FONT2TXT font.fnt');
 if ParamCount = 0 then Halt;
 Ps := Pos('.', ParamStr(1));
 if Ps = 0 then S := ParamStr(1) + '.TXT'
 else S := copy(ParamStr(1),1, Ps-1) + '.TXT';
 Assign(F,ParamStr(1));
 Reset(F, 1);
 if IOResult <> 0 then Halt;
 Assign(T, S);
 ReWrite(T);
 if IOResult <> 0 then Halt;
 BlockRead(F, Font, SizeOf(Font));
 Close(F);
 for Ch := 0 to 255 do
  begin
   Fnt2Txt(Font, Ch, Txt);
   if Ch >= $20 then
    begin
     Write(Char(Ch),' -', Ch, '       '#13);
     WriteLn(T, Char(Ch), ' - ', Ch);
    end
   else
    begin
     Write('  -', Ch, '       '#13);
     WriteLn(T, '  - ', Ch);
    end;
   for i := 23 downto 0 do WriteLn(T,Txt[i]);
  end;
 Close(T);
end.
